import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 30.10.2007
  * @author
  */

public class GUI extends JFrame {
  // Anfang Variablen
  private Fahrkartenautomat fahrkartenautomat = new Fahrkartenautomat();
  
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JButton bA = new JButton();
  private JButton bB = new JButton();
  private JButton bC = new JButton();
  private JTextField tfTicketpreis = new JTextField();
  private JButton b10Cent = new JButton();
  private JButton b20Cent = new JButton();
  private JButton b50Cent = new JButton();
  private JButton b100Cent = new JButton();
  private JButton b200Cent = new JButton();
  private JTextField tfGezahlt = new JTextField();
  private JButton bDrucken = new JButton();
  private JTextField tfRueckgeld = new JTextField();
  // Ende Variablen

  public GUI(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { System.exit(0); }
    });
    int frameWidth = 300;
    int frameHeight = 324;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2 ;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel1.setBounds(56, 8, 171, 32);
    jLabel1.setText("Ticketautomat");
    jLabel1.setFont (new Font("arial", Font.PLAIN, 23));
    cp.add(jLabel1);
    jLabel2.setBounds(16, 56, 62, 16);
    jLabel2.setText("Preisstufe:");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    bA.setBounds(16, 80, 50, 33);
    bA.setFont (new Font("Arial", Font.PLAIN, 13));
    bA.setText("A");
    cp.add(bA);
    bA.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        bAActionPerformed(evt);
      }
    });

    bB.setBounds(72, 80, 50, 33);
    bB.setFont (new Font("arial", Font.PLAIN, 13));
    bB.setText("B");
    cp.add(bB);
    bB.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        bBActionPerformed(evt);
      }
    });

    bC.setBounds(128, 80, 50, 33);
    bC.setFont (new Font("arial", Font.PLAIN, 13));
    bC.setText("C");
    cp.add(bC);
    bC.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        bCActionPerformed(evt);
      }
    });

    tfTicketpreis.setBounds(16, 144, 113, 24);
    tfTicketpreis.setText("");
    cp.add(tfTicketpreis);
    b10Cent.setBounds(192, 56, 80, 25);
    b10Cent.setText("10 Cent");
    b10Cent.setEnabled(false);
    cp.add(b10Cent);
    b10Cent.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        b10CentActionPerformed(evt);
      }
    });

    b20Cent.setBounds(192, 88, 80, 25);
    b20Cent.setText("20 Cent");
    cp.add(b20Cent);
    b20Cent.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        b20CentActionPerformed(evt);
      }
    });

    b50Cent.setBounds(192, 120, 80, 25);
    b50Cent.setText("50 Cent");
    cp.add(b50Cent);
    b50Cent.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        b50CentActionPerformed(evt);
      }
    });

    b100Cent.setBounds(192, 152, 80, 25);
    b100Cent.setText("1 Euro");
    cp.add(b100Cent);
    b100Cent.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        b100CentActionPerformed(evt);
      }
    });

    b200Cent.setBounds(192, 184, 80, 25);
    b200Cent.setText("2 Euro");
    cp.add(b200Cent);
    b200Cent.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        b200CentActionPerformed(evt);
      }
    });

    tfGezahlt.setBounds(168, 216, 105, 24);
    tfGezahlt.setText("");
    cp.add(tfGezahlt);
    bDrucken.setBounds(48, 208, 97, 33);
    bDrucken.setText("Drucken");
    bDrucken.setEnabled(false);
    cp.add(bDrucken);
    bDrucken.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        bDruckenActionPerformed(evt);
      }
    });

    tfRueckgeld.setBounds(48, 248, 97, 24);
    tfRueckgeld.setText("");
    cp.add(tfRueckgeld);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
    geldstueckknoepfeFreigeben(false);
  }

  // Anfang Ereignisprozeduren

  public void bAActionPerformed(ActionEvent evt) {
    fahrkartenautomat.setzeTicketpreis(170);
    tfTicketpreis.setText("1,70 ");
    geldstueckknoepfeFreigeben(true);
    tfRueckgeld.setText("");
  }

  public void bBActionPerformed(ActionEvent evt) {
    fahrkartenautomat.setzeTicketpreis(320);
    tfTicketpreis.setText("3,20 ");
    geldstueckknoepfeFreigeben(true);
    tfRueckgeld.setText("");
  }

  public void bCActionPerformed(ActionEvent evt) {
    fahrkartenautomat.setzeTicketpreis(540);
    tfTicketpreis.setText("5,40 ");
    geldstueckknoepfeFreigeben(true);
    tfRueckgeld.setText("");
  }

  public void b10CentActionPerformed(ActionEvent evt) {
    einwurfAnzeigen(10);
  }

  public void b20CentActionPerformed(ActionEvent evt) {
    einwurfAnzeigen(20);
  }

  public void b50CentActionPerformed(ActionEvent evt) {
    einwurfAnzeigen(50);
  }

  public void b100CentActionPerformed(ActionEvent evt) {
    einwurfAnzeigen(100);
  }

  public void b200CentActionPerformed(ActionEvent evt) {
    einwurfAnzeigen(200);
  }

  public void bDruckenActionPerformed(ActionEvent evt) {
    if (fahrkartenautomat.ticketDrucken() == true)
    {
      tfRueckgeld.setText(""+((double)fahrkartenautomat.gezahlt-(double)fahrkartenautomat.ticketpreis)/100+"0 ");
      tarifknoepfeFreigeben(true);
    } else {
      tfRueckgeld.setText("kein Wechselgeld vorhanden!");
    }
    bDrucken.setEnabled(false);
    fahrkartenautomat.startzustand();
    tfTicketpreis.setText("");
    tfGezahlt.setText("");
  }

  // Ende Ereignisprozeduren

  public void einwurfAnzeigen(int geldstueck)
  {
    tarifknoepfeFreigeben(false);
    fahrkartenautomat.einzahlen(geldstueck);
    tfGezahlt.setText(""+(double)fahrkartenautomat.gezahlt/100+"0 ");
    if (fahrkartenautomat.gezahlt >= fahrkartenautomat.ticketpreis)
    {
      bDrucken.setEnabled(true);
      geldstueckknoepfeFreigeben(false);
    }
  }
  
  void tarifknoepfeFreigeben(boolean wert)
  {
    bA.setEnabled(wert);
    bB.setEnabled(wert);
    bC.setEnabled(wert);
  }
  
  void geldstueckknoepfeFreigeben(boolean wert)
  {
    b10Cent.setEnabled(wert);
    b20Cent.setEnabled(wert);
    b50Cent.setEnabled(wert);
    b100Cent.setEnabled(wert);
    b200Cent.setEnabled(wert);
  }
  
  public static void main(String[] args) {
    new GUI("GUI");
  }
}

