class Kasse {

  int m10, m20, m50, m100, m200;
  
  
  public Kasse()
  {
    m10 = 10;
    m20 = 10;
    m50 = 10;
    m100 = 10;
    m200 = 10;
  }

  /**
   * Methode zum Einzahlen eines Geldstcks
   * @param geldstueck  das Geldstck, welches eingezahlt wird.
   */

  public void einzahlen(int geldstueck)
  {
    switch (geldstueck) {
      case 10: m10++; break;
      case 20: m20++; break;
      case 50: m50++; break;
      case 100: m100++; break;
      case 200: m200++; break;
    }
  }
  
  /**
   * Methode zum Auszahlen eines Geldstcks
   * @param geldstueck : das Geldstck, welches eingezahlt wird.
   * @return boolean   true, wenn es das Geldstueck noch gab, sonst false.
   */

  public boolean auszahlen(int geldstueck)
  {
    switch (geldstueck) {
      case 10: if (m10>0) m10--; else return false; break;
      case 20: if (m20>0) m20--; else return false; break;
      case 50: if (m50>0) m50--; else return false; break;
      case 100: if (m100>0) m100--; else return false; break;
      case 200: if (m200>0) m200--; else return false; break;
    }
    return true;
  }

  public boolean betragAuszahlen(int betrag)
  {
    while ((betrag >= 200) && (auszahlen(200)==true)) {
      betrag -= 200;
    }
    while ((betrag >= 100) && (auszahlen(100)==true)) {
      betrag -= 100;
    }
    while ((betrag >= 50) && (auszahlen(50)==true)) {
      betrag -= 50;
    }
    while ((betrag >= 20) && (auszahlen(20)==true)) {
      betrag -= 20;
    }
    while ((betrag >= 10) && (auszahlen(10)==true)) {
      betrag -= 10;
    }

    if (betrag == 0)
    {
      return true;
    } else {
      return false;
    }
  }

  public static void main(String args[])
  {
    Kasse k = new Kasse();
    if (k.betragAuszahlen(10000) == true)
    {
      System.out.println("Ja");
    } else {
      System.out.println("Nein");
    }

  }

}

